import React, { Component } from "react";
import { connect } from "react-redux";
import { bindActionCreators } from "redux";
import actions from "../actions";

import { takeInputValue, getWeather } from "../actions/weather";

class FetchPage extends Component {
	state = {
		foo: 1,
		files: null,
		photo: null,
		url: "https://test-app-a-level.herokuapp.com"
	};

	async componentDidMount() {
		const lol = await fetch("https://jsonplaceholder.typicode.com/todos/1").catch(() => null);

		if (!lol) console.log("lol", lol);
	}

	add = () => this.setState(prevState => ({ foo: prevState.foo + 1 }));

	change = e => {
		const { takeInputValue } = this.props;
		takeInputValue(e.target.value);
	};

	click = () => {
		const { city, getWeather } = this.props;
		getWeather(city);
	};

	change = e => {
		const reader = new FileReader();

		const file = e.target.files[0];

		this.setState({ file });

		reader.onloadend = () => {
			this.setState({
				photo: reader.result
			});
		};
		reader.readAsDataURL(file);
	};

	post = () => {
		const file = new FormData();

		file.append("file", this.state.file);

		// fetch(`${this.state.url}/auth/upload`, {
		// 	method: "POST",
		// 	// headers: {
		// 	// 	"Content-Type": "multipart/form-data"
		// 	// },
		// 	body: file
		// })
		// 	.then(res => res.json())
		// 	.then(res => console.log("res", res))
		// 	.catch(err => console.log("res", err));

		fetch(`http://localhost:5000/category`, {
			method: "GET"
			// headers: {
			// "Content-Type": "application/json"
			// 	Accept: "application/json"
			// }
		})
			.then(res => res.json())
			.then(res => console.log("res", res))
			.catch(err => console.log("res", err));
	};

	render() {
		const { weather, error } = this.props;
		console.log("this.", this.props);
		const { photo } = this.state;
		return (
			<div className="page">
				<input className="page__input page__input--blue" type="text" onChange={this.change} />
				<button className="page__button" onClick={this.click}>
					SHOW
				</button>

				<div>
					<img src={`${this.state.url}/static/img/1547758776732-frog.jpeg`} alt="asdfas" />
					<input type="file" onChange={e => this.change(e)} />
					<button onClick={this.post}>POST FILE</button>
				</div>

				<div>{weather && weather.location && weather.location.city}</div>
				<div>{error && error}</div>

				<button onClick={this.add}>PUSH ME</button>
			</div>
		);
	}
}

const mapStateToProps = state => ({
	city: state.w.city,
	weather: state.w.weather,
	error: state.w.error
});

const mapDispatchToProps = dispatch =>
	bindActionCreators({ takeInputValue, getWeather, ...actions }, dispatch);

export default connect(
	mapStateToProps,
	mapDispatchToProps
)(FetchPage);
